VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FileSystem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "               NTFS."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
'      .
'    ,  
' .
'---   -------------------------------
Const GMEM_MOVEABLE = &H2
Const LMEM_FIXED = &H0
Const LMEM_ZEROINIT = &H40
Const LPTR = (LMEM_FIXED + LMEM_ZEROINIT)

Const DACL_SECURITY_INFORMATION = &H4
Const SECURITY_DESCRIPTOR_REVISION = 1
Const SECURITY_DESCRIPTOR_MIN_LENGTH = 20
Const SD_SIZE = (65536 + SECURITY_DESCRIPTOR_MIN_LENGTH)
Const ACL_REVISION2 = 2
Const ACL_REVISION = 2
Const MAXDWORD = &HFFFFFFFF
Const SidTypeUser = 1
Const AclSizeInformation = 2

Const OBJECT_INHERIT_ACE = &H1
Const CONTAINER_INHERIT_ACE = &H2
Const NO_PROPAGATE_INHERIT_ACE = &H4
Const INHERIT_ONLY_ACE = &H8
Const INHERITED_ACE = &H10
Const VALID_INHERIT_FLAGS = &H1F
Const DELETE = &H10000
'---  ------------------------------------------------
Type ACE_HEADER
   AceType As Byte
   AceFlags As Byte
   AceSize As Integer
End Type
Type ACCESS_DENIED_ACE
  Header As ACE_HEADER
  Mask As Long
  SidStart As Long
End Type
Type ACCESS_ALLOWED_ACE
   Header As ACE_HEADER
   Mask As Long
   SidStart As Long
End Type
Type ACL
   AclRevision As Byte
   Sbz1 As Byte
   AclSize As Integer
   AceCount As Integer
   Sbz2 As Integer
End Type
Type ACL_SIZE_INFORMATION
   AceCount As Long
   AclBytesInUse As Long
   AclBytesFree As Long
End Type
Type SECURITY_DESCRIPTOR
   Revision As Byte
   Sbz1 As Byte
   Control As Long
   Owner As Long
   Group As Long
   sACL As ACL
   Dacl As ACL
End Type
Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Long
    bInheritHandle As Long
End Type
'--- API  -------------------------------------------
Private Declare Function GetComputerName Lib "kernel32" Alias "GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long
Private Declare Function GetUserName Lib "advapi32.dll" Alias "GetUserNameA" (ByVal lpBuffer As String, nSize As Long) As Long
Private Declare Function LookupAccountName Lib "advapi32.dll" Alias "LookupAccountNameA" (lpSystemName As String, ByVal lpAccountName As String, sid As Any, cbSid As Long, ByVal ReferencedDomainName As String, cbReferencedDomainName As Long, peUse As Long) As Long
Private Declare Function InitializeSecurityDescriptor Lib "advapi32.dll" (pSecurityDescriptor As SECURITY_DESCRIPTOR, ByVal dwRevision As Long) As Long
Private Declare Function GetAclInformation Lib "advapi32.dll" (ByVal pAcl As Long, pAclInformation As Any, ByVal nAclInformationLength As Long, ByVal dwAclInformationClass As Long) As Long
Private Declare Function EqualSid Lib "advapi32.dll" (pSid1 As Byte, ByVal pSid2 As Long) As Long
Private Declare Function GetLengthSid Lib "advapi32.dll" (pSid As Any) As Long
Private Declare Function InitializeAcl Lib "advapi32.dll" (pAcl As Byte, ByVal nAclLength As Long, ByVal dwAclRevision As Long) As Long
Private Declare Function GetAce Lib "advapi32.dll" (ByVal pAcl As Long, ByVal dwAceIndex As Long, pace As Any) As Long
Private Declare Function AddAce Lib "advapi32.dll" (ByVal pAcl As Long, ByVal dwAceRevision As Long, ByVal dwStartingAceIndex As Long, ByVal pAceList As Long, ByVal nAceListLength As Long) As Long
Private Declare Function AddAccessAllowedAce Lib "advapi32.dll" (pAcl As Byte, ByVal dwAceRevision As Long, ByVal AccessMask As Long, pSid As Byte) As Long
Private Declare Function AddAccessDeniedAce Lib "advapi32.dll" (pAcl As Byte, ByVal dwAceRevision As Long, ByVal AccessMask As Long, pSid As Byte) As Long
Private Declare Function SetSecurityDescriptorDacl Lib "advapi32.dll" (pSecurityDescriptor As SECURITY_DESCRIPTOR, ByVal bDaclPresent As Long, pDacl As Byte, ByVal bDaclDefaulted As Long) As Long
Private Declare Function CreateDirectory Lib "kernel32" Alias "CreateDirectoryA" (ByVal lpPathName As String, lpSecurityAttributes As SECURITY_ATTRIBUTES) As Long
Private Declare Function MessageBox Lib "user32" Alias "MessageBoxA" (ByVal hwnd As Long, ByVal lpText As String, ByVal lpCaption As String, ByVal wType As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, ByVal hpvSource As Long, ByVal cbCopy As Long)
'---  ---------------------------------------------

Public Type SecurityInfo
    uName As String
    uMask As AccessType
    bUserSid(255) As Byte
End Type

Public Enum AccessType
    GENERIC_READ = &H80000000
    GENERIC_ALL = &H10000000
    GENERIC_EXECUTE = &H20000000
    GENERIC_WRITE = &H40000000
End Enum

Private mvarDefaultedDACL As Long
Public Property Let DefaultedDACL(ByVal vData As Long)
Attribute DefaultedDACL.VB_Description = "   0        ."
    If vData > 1 Then vData = 1
    mvarDefaultedDACL = vData
End Property

Public Property Get DefaultedDACL() As Long
    DefaultedDACL = mvarDefaultedDACL
End Property

Public Function CreateFolder(sFolderPath As String, sInfo() As SecurityInfo) As Long
Attribute CreateFolder.VB_Description = "             SecirutyInfo     ."
Dim lResult As Long                   '     API 
Dim i As Integer                      '  
Dim sDomainName As String * 255       '    
Dim lDomainNameLength As Long         '  
Dim lSIDType As Long                  '  SID
Dim sFolderSA As SECURITY_ATTRIBUTES  '     SA
Dim sNewSD As SECURITY_DESCRIPTOR     ' SECURITY_DESCRIPTOR
Dim sACL As ACL                       ' ACL
Dim lNewACLSize As Long               '  ACL
Dim bNewACL() As Byte                 '   ACL.
Dim sCurrentACE As ACCESS_ALLOWED_ACE ' ACE.
Dim pCurrentACE As Long               '  
    '=================    ====================
    '============================================================
    '  InitializeSecurityDescriptor    SecurityDescriptor
    lResult = InitializeSecurityDescriptor(sNewSD, SECURITY_DESCRIPTOR_REVISION)
    '     -  .
    '      ,   
    If lResult = 0 Then Err.Raise 65001, "VBSecurity::FileSystem", "    SD"
    lNewACLSize = Len(sACL) - 4
    For i = 1 To UBound(sInfo)
        If sInfo(i).uName <> "" Then
            '    SID    .   
            '     ,    
            lResult = LookupAccountName(vbNullString, sInfo(i).uName, sInfo(i).bUserSid(0), 255, sDomainName, lDomainNameLength, lSIDType)
            sDomainName = Space(lDomainNameLength)
            lResult = LookupAccountName(vbNullString, sInfo(i).uName, sInfo(i).bUserSid(0), 255, sDomainName, lDomainNameLength, lSIDType)
            If lResult = 0 Then Err.Raise 65002, "VBSecurity::FileSystem", "   SID   \" & vbCrLf & "'" & sInfo(i).uName & "'"
            lNewACLSize = lNewACLSize + Len(sCurrentACE) + GetLengthSid(sInfo(i).bUserSid(0))
            DoEvents
        Else
            '    ,      
            '   ,   ,   
            '   )
            Err.Raise 65006, "VBSecurity::FileSystem", "   "
        End If
        '     -,    
        ' ,     ACL -   
        If sInfo(i).uMask = 0 Then sInfo(i).uMask = GENERIC_READ
    Next i
    '   AccessControlList     
    '   
    ReDim bNewACL(lNewACLSize)
    lResult = InitializeAcl(bNewACL(0), lNewACLSize, ACL_REVISION)
    If lResult = 0 Then Err.Raise 65003, "VBSecurity::FileSystem", "    ACL"
    '    ACE   ACL
    For i = 1 To UBound(sInfo)
        lResult = AddAccessAllowedAce(bNewACL(0), ACL_REVISION, sInfo(i).uMask, sInfo(i).bUserSid(0))
        If lResult = 0 Then Err.Raise 65004, "VBSecurity::FileSystem", "   ACE  ACL"
        DoEvents
        '-----------------         INHERITANCE   
        '     () ACE
        lResult = GetAce(VarPtr(bNewACL(0)), i - 1, pCurrentACE)
        If lResult = 0 Then Err.Raise 65005, "VBSecurity::FileSystem", "       ACE  ACL"
        ' ,  ACE  
        CopyMemory sCurrentACE, pCurrentACE, LenB(sCurrentACE)
        ' 
        sCurrentACE.Header.AceFlags = OBJECT_INHERIT_ACE + CONTAINER_INHERIT_ACE + NO_PROPAGATE_INHERIT_ACE '+ INHERIT_ONLY_ACE
        ' 
        CopyMemory ByVal pCurrentACE, VarPtr(sCurrentACE), LenB(sCurrentACE)
        'add another ACE for files
        '-------------------   INHERITANCE 
    Next i
    '  ASL    SD
    lResult = SetSecurityDescriptorDacl(sNewSD, 1, bNewACL(0), mvarDefaultedDACL)
    If lResult = 0 Then Err.Raise 65005, "VBSecurity::FileSystem", "    ACL  SD"
    '     SECURITY_ATTRIBUTE
    sFolderSA.bInheritHandle = True
    sFolderSA.lpSecurityDescriptor = VarPtr(sNewSD)
    sFolderSA.nLength = Len(sNewSD)
    '   
    MsgBox CreateDirectory(sFolderPath, sFolderSA)
End Function

Public Sub About()
    MessageBox 0, "VBSecurity::FileSystem sample object" & vbCrLf & "Copyright 2004-2005 Tsioka Alexander." & vbCrLf & "No Visual Basic controls and objects used. Win32 API only.", "About", 32
End Sub

Private Sub Class_Initialize()
    mvarDefaultedDACL = 0
End Sub
